function DataManagerController(){
	var self = this; self.name = "DataManagerController"; // MANDATORY

	this.reader = new XMLDataReader();

	this.load = function(url,timestamp){
        if(typeof(timestamp) !== "undefined"){this.timestamp = timestamp;}
        $(this.reader).on("XMLDataReaderDataLoaded",this.onReaderReady);
        $(this.reader).on("XMLDataReaderDataError",this.onReaderError);
				this.reader.loadURL(url,timestamp);
	};
	
	this.loadDataXML = function(data){
				$(this.reader).on("XMLDataReaderDataLoaded",this.onReaderReady);
				$(this.reader).on("XMLDataReaderDataError",this.onReaderError);
				this.reader.loadXML(data);
	};
	
	this.loadDataXML = function(data){
		$(this.reader).on("XMLDataReaderDataLoaded",this.onReaderReady);
		$(this.reader).on("XMLDataReaderDataError",this.onReaderError);
		this.reader.loadXML(data);
	};

    this.getTimestamp = function(){
        return parseInt(this.reader.timestamp);
    };

    this.getPlaylistType = function(){
        var timeline = this.reader.timeline();
        if(timeline){
            timeline = null;
            return "TimelineController";
        }else{
            var loop = this.reader.loops();
            if(loop){
                loop = null;
                return "PlaylistController";
            }else{
                self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+1,self.name+": Function getPlaylistType() failed");
                return false;
            }
        }
    };

    this.onReaderReady = function(){
        $(self.reader).off("XMLDataReaderDataLoaded",self.onReaderReady);
        $(self.reader).off("XMLDataReaderDataError",self.onReaderError);
        $(self).trigger("DataManagerControllerDataLoaded");
    }

    this.onReaderError = function(){
        $(self.reader).off("XMLDataReaderDataError",self.onReaderError);
        $(self.reader).off("XMLDataReaderDataLoaded",self.onReaderReady);
        //$(self).trigger("DataManagerControllerDataError");
				self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+9,self.name+": Function onReaderError() failed: An error occurred reading XML Data");
				$(self).trigger("DataManagerControllerDataLoaded");
    }

    this.getArchiveFileItemById = function(id){
		var xml_node = this.reader.file(id);
		if(xml_node){
			return new ContentElement(xml_node);
		}else{
			return false;
		}
	};

	this.getBlockById = function(id){
		var xml_node = this.reader.block(id);
		if(xml_node){
			return new BlockElement(xml_node);
		}else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+3,self.name+": Function getBlockById() failed");
			return false;
		}
	};

    this.getTemplateById = function(id){
		var xml_node = this.reader.template(id);
		if(xml_node){
			return new TemplateElement(xml_node);
		}else{
			return false;
		}
	};

    this.getConfig = function(){
		var xml_node = this.reader.configuration();
		if(xml_node){
			return new ConfigElement(xml_node);
		}else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+5,self.name+": Function getConfig() failed");
			return false;
		}
    };

    this.getStats = function(){
		var xml_node = this.reader.stats();
		if(xml_node){
			return new StatsElement(xml_node);
		}else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+6,self.name+": Function getStats() failed");
			return false;
		}
    };

    this.getConditions = function(){
        var types_node = this.reader.condition_types();
		if(types_node){
            var triggers_node = this.reader.condition_trigger();
			return new ConditionsElement(types_node,triggers_node);
		}else{
           return false;
		}
    };

    this.createArchiveFileItem = function(id,filename,duration){
        return new ContentElement($($.parseXML('<files id="'+id+'" filename="'+filename+'" duration="'+duration+'"/>')).children().eq(0));
    };

    this.reportStatistics = function(content_id,campaign_id,conditions){
        if(self.platform != "WEB"){
            var stats = self.getStats();
            if(stats){
                var stats_report = stats.getStatType();
                if(content_id >= 0){
                    var player_id = self.getConfig().getId();
                    var date = self.getDate();
										var timezone =  date.getTimezoneOffset();
                    var timestamp = parseInt(date.getTime()/1000);
										if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC"){
											timestamp = timestamp + (timezone*60*-1);
	                  }
										if(self.getStats().getStatType() == 1 || stats_report == 2){
                        var stat = self.getStats().createPlayerStat(timestamp,player_id,content_id,campaign_id,conditions);
                        self.log("New Stat = "+stat);
                        var stat_filename = self.ROUTES['STAT'].path+player_id+"_"+timestamp+".json";
                        self.OS.writeFile(stat_filename,stat);
                    }
                    if(stats_report == 3 || stats_report == 2){
                        var analytic = self.getStats().createAnalyticStat(timestamp,player_id,content_id,campaign_id,conditions);
                        self.log("New Analytic = "+analytic);
                        var analytic_dir = self.ROUTES['ANALYTIC'].path;
                        var analytic_filename = analytic_dir+player_id+"_"+timestamp+".json";
                        self.OS.writeFile(analytic_filename,analytic);
                    }
                }
            }else{
                self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+2,self.name+": Function getStats() failed");
            }
        }
    };

    this.selectLoop = function(){
        var selected = 0;
        var now = self.getDate();
        var timestamp_now = parseInt(now.getTime()/1000);
        var minute_of_today = self.getTotalMinutesToday(now);
        var dow = now.getDay()-1; if(dow < 0 ){dow = 6;}
        var min_distance = 1440;
        var warning = "";

        $(self.reader.loops().find('list')).each(function(){
            var info = self.getLoopInfo($(this));
						self.log("Playlist "+info['id']+" At minute : "+minute_of_today+" DOW : "+dow);
            info['in_range'] = self.isTimestampInRange(info['start_timestamp'],timestamp_now,info['end_timestamp']);
            if(info['in_range']){
                if(self.isPlayingToday(info['days_of_week'],dow)){
                    info['in_range'] = self.isTimeInRange(info['start_minute'],minute_of_today,info['end_minute']);
                    if(info['in_range']){
                        var distance = minute_of_today - info['start_minute'];
                        if(distance < min_distance){
                            min_distance = distance;
                            selected = info['id'];
                        }
                    }else{
                        warning = "Playlist id : "+info['id']+" is out of time for today.";
                        self.log(warning);
                    }
                }else{
                    warning = "Playlist id : "+info['id']+" is not playing today.";
                    self.log(warning);
                }
                info['in_range'] = null;
            }else{
                warning = "Playlist id : "+info['id']+" is out of dates.";
                self.log(warning);
            }
            info = null;
        });
				self.log("Selected "+selected);
        if(selected > 0){
            return $(self.reader.loops()).find("list[id='"+selected+"']");
        }else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+7,self.name+": Function selectLoop() failed : "+warning);
            return false;
        }
    };

    this.getBlocks = function(){
        var xml_node = self.reader.loops().find('blocks');
		if(xml_node){
			return xml_node;
		}else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+8,self.name+": Function getBlocks() failed");
			return false;
		}
    };

    this.getLoopInfo = function(loop){
        var info = {};
        info['id'] = loop.attr('id');
        info['in_range'] = false;
        info['start_timestamp'] = parseFloat(loop.attr('startDate'));
        info['end_timestamp'] = parseFloat(loop.attr('endDate'));
        info['start_minute'] = parseFloat(loop.attr('startHour'));
        info['end_minute'] = parseFloat(loop.attr('endHour'));
        if(info['end_minute'] == 0){info['end_minute'] = 1440;}
        info['days_of_week'] = loop.attr('dow');
        return info;
    };

    this.isTimestampInRange = function(start_tstamp,now_tstamp,end_tstamp){
        var in_range = false;
        //self.log("Timestamps in range : "+start_tstamp+" < [ "+now_tstamp+" ] > "+end_tstamp);
        if(now_tstamp >= start_tstamp  && now_tstamp <= end_tstamp){
            in_range = true;
        }
        return in_range;
    };

    this.isTimeInRange = function(start_minute,now_minute,end_minute){
        var in_range = false;
        self.log("Minute of the day in range : "+start_minute+" < [ "+now_minute+" ] > "+end_minute);
        if(now_minute >= start_minute  && now_minute <= end_minute){
            in_range = true;
        }
        return in_range;
    };

    this.getTotalMinutesToday = function(now){
				var hours = 0;
				var minutes = 0;
				if(self.server_time_activated){
            hours = now.getUTCHours();
            minutes = now.getUTCMinutes();
        }else{
            hours = now.getHours();
            minutes = now.getMinutes();
        }
				self.log("Hours : "+hours+" Minutes : "+minutes);
        return (hours*60) + minutes;
    };

    this.isPlayingToday = function(weekdays,dow){
        if(weekdays[dow] == 1){
            return true;
        }else{
            return false;
        }
    };

    this.getArchiveFiles = function(files){
        var archive = $(self.reader.archive()).find("files");
        if(typeof(files) === "undefined" || typeof(files) === "boolean"){files = [];}
				var filename_list = [];
				for(var k=0;k<files.length;k++){filename_list.push(files[k].filename);}
        var filename = "";
        var url = "";
        var id = "0";
        var tstamp = 0;
        var file_index = -1;
        for(var i=0;i<archive.length;i++){
            var ready = true;
            var attach = [];
            if($(archive[i]).attr('attachments') == "1"){
								var main_filename = $(archive[i]).attr('filename');
		            main_filename = main_filename.substr(main_filename.lastIndexOf('/')+1,main_filename.length);
                ready = false;
                var attachments = $(archive[i]).find("attachment");
                for(var j=0;j<attachments.length;j++){
                    filename = $(attachments[j]).attr('filename');
                    filename = filename.substr(filename.lastIndexOf('/')+1,filename.length);
										file_index = filename_list.indexOf(filename);
                    if(file_index < 0 && filename != main_filename){
												var attach_url = $(attachments[j]).attr('url');
												attach_url = attach_url.replace("api.admira.mobi",self.api_server_url);												
												files.push({'id': false,
                                    'identifier': $(archive[i]).attr('id')+"-"+$(attachments[j]).attr('id'),
                                    'filename':filename,
																		'hash':"",
                                    'url':attach_url,
                                    'downloaded':false,
                                    'attachments':false,
                                    'tstamp':$(attachments[j]).attr('tstamp'),
                                    'ready':true
                                });

                        attach.push({'id':id,'filename':filename,'index':(files.length-1)});
                    }
                }
            }
            filename = $(archive[i]).attr('filename');
            filename = filename.substr(filename.lastIndexOf('/')+1,filename.length);
						file_index = filename_list.indexOf(filename);
            if(file_index < 0){
                files.push({'id':$(archive[i]).attr('id'),
                            'identifier': $(archive[i]).attr('id'),
                            'filename':filename,
														'hash':$(archive[i]).attr('hash'),
                            'url':"/videos/"+$(archive[i]).attr('filename'),
                            'downloaded':false,
                            'attachments':attach,
                            'tstamp':$(archive[i]).attr('tstamp'),
                            'ready':ready
                        });
            }
        }
        return files;
    };

    this.getBase64XMLcopy = function(){
        var Base64 = "";
        try{
            var serialized = new XMLSerializer().serializeToString(self.reader.xml.eq(0)[0]);
            Base64 = btoa(serialized);
        }catch(e){
            self.log("could not create copy of XML on base64");
        }
        return Base64;
    };
    
    this.getScreens = function (){
     	self.log ("getScreens");
        var screens = [];
    	var xml_node = self.reader.screens();
		if(xml_node){
			self.log("screens found")
	    	var xml_screens = xml_node.find("screen");
			for(var i=0;i<xml_screens.length;i++){
				self.log("screen found: " + i)
				var screen = {};
				screen ['id']           = parseInt( $(xml_screens[i]).attr('id') ) ;
				screen ['remote_id']    = parseInt( $(xml_screens[i]).attr('remote_id') );
				screen ['port']         =           $(xml_screens[i]).attr('port');
				screen ['model']        = parseInt( $(xml_screens[i]).attr('model') );
				screen ['schedule']     =           $(xml_screens[i]).attr('schedule');
                var exceptions = [];
                var xml_exceptions = $(xml_screens[i]).find("screen_exception");
                for(var j=0;j<xml_exceptions.length;j++){
                    self.log ("exception found: " + j )
                    exceptions.push ( parseInt( $(xml_exceptions[j]).attr('id') ) );
                }
                screen ['exceptions'] = exceptions;
				screens.push ( screen );
			}
			return screens;
		}else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+5,self.name+": Function getScreens() failed");
			return screens;
		}
    }

    this.getExceptions = function (){
        self.log ("getExceptions");
        var exceptions = [];
        var xml_node = self.reader.screenExceptions();
        if(xml_node){
            self.log("exceptions found")
            var exceptions = [];
            var xml_exceptions = xml_node.find("screen_exception");
            for(var i=0;i<xml_exceptions.length;i++){
                self.log("exception found: " + i)
                var exception = {};
                exception['id']         = parseInt( $(xml_exceptions[i]).attr('id') );
                exception['schedule']   =           $(xml_exceptions[i]).attr('schedule');
                exception['type']       = parseInt( $(xml_exceptions[i]).attr('type') );
                exception['copyday']    = parseInt( $(xml_exceptions[i]).attr('copyday') );
                exception['day']        = parseInt( $(xml_exceptions[i]).attr('day') );
                exceptions.push ( exception );
            }
            return exceptions;
        }else{
            self.notifyError(self.ERROR['DATA_MANAGER_CONTROLLER']+5,self.name+": Function getExceptions() failed");
            return exceptions;
        }
    }

}
DataManagerController.prototype = new SystemController();
